package com.csc.library.command;

import java.util.Collections;
import java.util.Map;

import com.csc.library.factory.ResponseFactory;
import com.csc.library.properties.CscSession;
import com.csc.library.request.CMDMode;
import com.csc.library.request.CommandState;
import com.csc.library.request.RequestWebsocket;
import com.csc.library.response.ResponseStatus;
import com.csc.library.utilities.UProfile;

public abstract class CommandBase<T> implements CscCommand<T>{
	protected CMDMode commandMode = null;
	private CscSession session = null;
	private RequestWebsocket request = null;
	private Map<String,String> paramConfig = null;
	private CommandState commandState = CommandState.noAction;
	
	public final void setSession(CscSession session){
		this.session = session;
	}
	
	public final CscSession getSession(){
		return this.session;
	}
	
	public final void setRequest(RequestWebsocket req){
		this.request = req;
	}
	
	public final RequestWebsocket getRequest(){
		return this.request;
	}
	
	public final UProfile getUProfile(){
		return this.session.getUProfile();
	}
	
	public final void setParamConfig(Map<String, String> param){
		this.paramConfig = param;
	}
	
	public Map<String, String> getParamConfig(){
		return this.paramConfig;
	}
	public final void setCommandState(CommandState state){
		this.commandState = state;
	}
	
	public CommandState getCommandState(){
		return this.commandState;
	}

	public final void sendMessage(String message){
		ResponseFactory.getInstance().sendResponseWebsocket(
				this.getSession(), 
				this.getRequest(), 
				this.commandState,
				ResponseStatus.SendMessage, 
				message);
	}
	public final void sendMessage(String message , CommandState stateComm ){
		this.setCommandState(stateComm);
		ResponseFactory.getInstance().sendResponseWebsocket(
				this.getSession(), 
				this.getRequest(), 
				this.commandState,
				ResponseStatus.SendMessage , 
				message);
	}
}
