package com.csc.library.command.ftp;

import java.io.File;

import com.csc.library.command.CommandFileResult;
import com.csc.library.factory.FileFtpFactory;
import com.csc.library.properties.JsonFile;
import com.csc.library.properties.JsonFileImpl;
import com.csc.library.request.CommandState;
import com.csc.library.session.InitialEnvironment;

public class DownloadFtp extends CommandFileResult<JsonFile>{

	@Override
	public void execute(JsonFile param) throws Exception {
		String dirupload = new InitialEnvironment().getValue(param.getDirectory());
		File file = new File(dirupload+"/"+param.getFileName());
		if(file.exists()){
			this.setFile(FileFtpFactory.getInstance().createJsonFile(file));
			this.sendMessage("DownloadFtp : Success" , CommandState.success);
		}else{
			this.sendMessage("DownloadFtp : Fail because file not found." , CommandState.fail);
		}
	}
}
