package com.csc.library.command.special;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;

import com.csc.library.command.CommandBase;
import com.csc.library.command.CommandLists;
import com.csc.library.database.DataSet;
import com.csc.library.fix.StaticVariable;
import com.csc.library.request.CommandState;
import com.csc.library.response.ResponseData;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.utilities.MyLog;

public class CommandSpecialBase extends CommandLists<List<String>>{
	
	public void execute(List<String> param) throws Exception {
		try{
			String sql = this.getSQLConfig();
			for(int i = 0; i < param.size(); i++){
				String regex = "{"+i+"}";
				sql = StringUtils.replace(sql , regex , "'"+param.get(i)+"'");
			}
			DataSet ds = new DataSet();
    		ds.setUPofile(this.getUProfile());
    		ds.setDbName(this.getUProfile().getDbName());
    		ds.setDbType(new InitialEnvironment(this.getUProfile().getDbName()).getValue("datasource-dbtype"));
    		ds.setSql(sql);
    		ds.initConnection(this.getUProfile());
    		
    		while(ds.next()){
    			Map<String,String> record = new HashMap<String,String>();
    			for(int i = 0; i < ds.getFieldList().size(); i++){
    				String field = (String)ds.getFieldList().get(i);
    				record.put(field, ds.getString(field));
    			}
    			this.putNewRecord(record);
    		}
    		this.setCommandState(CommandState.success);
		}catch(Exception e){
			MyLog.error(this ,this.getUProfile() , e);
			this.setCommandState(CommandState.fail);
		}
	}

	public final String getSQLConfig(){
		return this.getParamConfig().get(StaticVariable.CommandSpecialAttribute.SQL);
	}
}
