package com.csc.library.factory;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class ThreadsPoolsFactory {
	private static ThreadsPoolsFactory instance = null;
	private ExecutorService executor = Executors.newFixedThreadPool(5);
	private ThreadsPoolsFactory(){
	}
	
	public static ThreadsPoolsFactory getInstance(){
		if(instance == null){
			instance = new ThreadsPoolsFactory();
		}
		return instance;
	}
	
	public void execute(final Runnable r){
		executor.execute(new Runnable() {
			@Override
			public void run() {
				/* call begin thread */
				r.run();
				/* call ending thread */
			}
		});
	}
}
