package com.csc.library.properties;

import java.util.LinkedList;

import com.csc.library.response.ResponseWebsocket;

public class ResponsePools<T> {
	private static ResponsePools instance;
	private LinkedList<T> list = new LinkedList<T>();
	
	private ResponsePools(){}
	
	public static ResponsePools getInstance(){
		if(instance==null){
			instance = new ResponsePools();
		}
		return instance;
	}
	
	public synchronized void push(T res) {
	    synchronized (list) {
	        list.addLast(res);
	    }
	}
	
	public synchronized T pop() throws Exception {
	    synchronized (list) {
	        if (list.size() == 0) {
	        	return null;
	        }
	        return list.removeFirst();
	    }
	}
}
