package com.csc.library.websocket;

import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

import javax.websocket.CloseReason;
import javax.websocket.EndpointConfig;
import javax.websocket.OnClose;
import javax.websocket.OnError;
import javax.websocket.OnMessage;
import javax.websocket.OnOpen;
import javax.websocket.Session;
import javax.websocket.server.PathParam;
import javax.websocket.server.ServerEndpoint;

import com.csc.library.controller.WebSocketCommandController;
import com.csc.library.utilities.MyLog;
import com.csc.library.websocket.config.CscWsServerEndpointConfig;

@ServerEndpoint(
		value = "/TESTWS",
		configurator = CscWsServerEndpointConfig.class
)
public class WebSocketTest {
	private ServerWebSocket serverSocket = null;
	private WebSocketCommandController commandControl = WebSocketCommandController.getInstance();
	private static final Set<Session> sessions = new HashSet<Session>();
	@OnOpen
	public void open(Session session, EndpointConfig conf) throws IOException {
		serverSocket = ServerWebSocket.getInstance();
		sessions.add(session);
		
		for(Session ses : this.sessions){
			if(!ses.isOpen()){
				sessions.remove(ses);
			}
		}
		System.out.println("Open Connections Size : "+sessions.size());
	} 
	
	@OnClose
    public void close(Session session , CloseReason closeReason) {
		sessions.remove(session);
		System.out.println("Close Connections Size : "+sessions.size());
	}
	
	@OnError
	public void onError(Throwable error) {
	}
	
	@OnMessage
	public void handleMessage(Session session , String message)  throws IOException{
		session.getAsyncRemote().sendText(message);
		/*for(Session ses : this.sessions){
			if(session != ses){
				ses.getAsyncRemote().sendText(System.currentTimeMillis()+" : "+message);
			}
		}*/
	}
}
